/* -*- c -*- --------------------------------------------------------------- *
 *
 * linux/fs/autofs4/init.c
 *
 *  Copyright 1997-1998 Transmeta Corporation -- All Rights Reserved
 *
 * This file is part of the Linux kernel and is made available under
 * the terms of the GNU General Public License, version 2, or at your
 * option, any later version, incorporated herein by reference.
 *
 * ------------------------------------------------------------------------- */

#include <linux/module.h>
#include <linux/init.h>
#include "autofs_i.h"

static struct file_system_type autofs4_fs_type = {
	"autofs",
	0,
	autofs4_read_super,
	NULL
};

#ifdef MODULE
int init_module(void)
{
	return register_filesystem(&autofs4_fs_type);
}

int cleanup_module(void)
{
	return unregister_filesystem(&autofs4_fs_type);
}
#else
__initfunc(int init_autofs4_fs(void))
{
	return register_filesystem(&autofs4_fs_type);
}
#endif

