
/***************************************************************************
*
*   Copyright (c) 1998, 1999 Timpanogas Research Group, Inc.
*   895 West Center Street
*   Orem, Utah  84057
*   jmerkey@timpanogas.com
*
*   This program is free software; you can redistribute it and/or modify it
*   under the terms of the GNU General Public License as published by the
*   Free Software Foundation, version 2, or any later version.
*
*   This program is distributed in the hope that it will be useful, but
*   WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   General Public License for more details.
*
*   You are free to modify and re-distribute this program in accordance
*   with the terms specified in the GNU Public License.  The copyright
*   contained in this code is required to be present in any derivative
*   works and you are required to provide the source code for this
*   program as part of any commercial or non-commercial distribution.
*   You are required to respect the rights of the Copyright holders
*   named within this code.
*
*   jmerkey@timpanogas.com and TRG, Inc. are the official maintainers of
*   this code.  You are encouraged to report any bugs, problems, fixes,
*   suggestions, and comments about this software to jmerkey@timpanogas.com
*   or linux-kernel@vger.rutgers.edu.  New releases, patches, bug fixes, and
*   technical documentation can be found at www.timpanogas.com.  TRG will
*   periodically post new releases of this software to www.timpanogas.com
*   that contain bug fixes and enhanced capabilities.
*
*   Original Authorship      :
*      source code written by Jeff V. Merkey, TRG, Inc.
*
*   Original Contributors    :
*      Jeff V. Merkey, TRG, Inc.
*      Darren Major, TRG, Inc.
*      Alan Cox, RedHat Software, Inc.
*
****************************************************************************
*
*
*   AUTHOR   :  Jeff V. Merkey (jmerkey@timpanogas.com)
*   FILE     :  NWHELP.H
*   DESCRIP  :  FENRIS Menu Config Help Text
*   DATE     :  November 29, 1999
*
*
***************************************************************************/

BYTE *GeneralHelp[]=
{
   " ",
   "                          GENERAL HELP",
   "                          ------------",
   " ",
   "    This utility allows you to create and manage Netware Volumes,",
   "    Netware Partitions, and Netware Mirroring.  Each panel contains",
   "    it's own help text to guide you through managing and creating",
   "    Netware Volumes, Mirrors, Partitions, and Namespaces.",
   " ",
   "    The steps involved in creating a valid Netware File System",
   "    configuration are typically as follows:",
   " ",
   "    1.  Create Netware Partitions on Selected Disks.",
   "    2.  Select Which Partitions will be Mirrored.",
   "    3.  Combine Selected Partitions into Mirror Groups (if needed).",
   "    4.  Split/Mark Selected Segments Within These Partitions.",
   "    5.  Create The Volume(s).",
   "    6.  Modify Volume Namespaces (if needed).",
   " ",
   "    Additional information can be found by visiting TRG's website at",
   "    www.timpanogas.com",
   " ",
   "    NetWare and Novell are registered trademarks of Novell, Inc., ",
   "    Windows NT and Windows 2000 are registered trademarks of Microsoft",
   "    Corp.  All other trademarks are the property of their perspective",
   "    owners.",
   " "
   " ",
   "                    CREATING A NETWARE VOLUME",
   "                    -------------------------",
   " ",
   "    Prior to attempting to create a Netware volume, it is assumed that",
   "    you have first created a Netware Partition or Partitions, and that",
   "    you have also configured mirroring (if desired).  If you have not",
   "    completed these steps, then you should review the sections on",
   "    mirroring and paritition management before attempting to create",
   "    a Netware volume.",
   " ",
   "    NetWare volumes can consist of from 1 to 32 segments.  Segments",
   "    for a particular volume can exist on a single drive, or can be ",
   "    spanned (striped) across multiple drives.  Up to 8 segments ",
   "    can be created within a given Netware 3.x or 4.x/5.x partition.",
   " ",
   "    To Create a Netware Volume, you must first select and mark a group",
   "    of free segments that will comprise the volume.  You mark segments",
   "    by switching to the volume segment editor panel (by pressing the TAB",
   "    key from the main menu) and moving the cursor bar over a defined ",
   "    ***FREE*** segment, and pressing the SPACE bar. If you want to create",
   "    multiple segments from a block of partition ***FREE*** space, then ",
   "    move the cursor bar over the free area, and press ENTER.  You can ",
   "    then enter a size value in megabytes to define a segment you want to",
   "    split out of the block of free space.  You are limited to 8 segment",
   "    definitions for each partition.",
   " ",
   "    After you have marked your segment definitions and split free space",
   "    into the segment sizes you wish to use, then you can press ESC/F3, and",
   "    select the CREATE NETWARE VOLUME option on the main menu to complete",
   "    naming of the volume and specific options you may want to enable for",
   "    the volume.",
   " ",
   "    Netware volumes can also be extended after they have been created.",
   "    This allows administrators to add disks and storage to a server, and",
   "    extend the size of a volume by adding new segments to the end of the",
   "    volume.  If these segments span disks, the Netware file system",
   "    naturally load balances and stripes data across these segments.",
   "    You expand a volume by marking segments and defining them as described",
   "    above, and pressing ESC/F3 and selecting CREATE OR EXPAND VOLUME.",
   " ",
   "    If for any reason you have created a split segment definition and",
   "    you change your mind about your settings, you can press the DEL key",
   "    and clear your current segment definitions back to the default",
   "    values.",
   " ",
   "    Volume create allows you to determine which attributes a volume",
   "    will have.  The default values are the best choice, and should not",
   "    be altered unless you know what you are doing.",
   " ",
   " ",
   "                    VOLUME SEGMENT CONFIGURATION",
   "                    ----------------------------",
   " ",
   "    The segment editor allows you to create and manage segments and",
   "    assign them to create Netware volumes.   Netware partitions are",
   "    displayed in numeric order in the segment display window and any",
   "    space not currently assigned to existing Netware volumes is",
   "    annotated as ***FREE***.  Pressing the TAB key from the main",
   "    menu will switch you to the segment editor screen.",
   " ",
   "    There are performance benefits to striping segments across multiple",
   "    disk devices if present.",
   " ",
   "    Segments are the logical representation of a Mirror Group.  The",
   "    MirrorGroup number for each segment corresponds to the active",
   "    mirror group that makes up this segment of storage.",
   " ",
   "                   DISK PARTITION CONFIGURATION",
   "                   ----------------------------",
   " ",
   "    Novell supports the following partition types:",
   " ",
   "    Type           Netware File System/OS",
   "    ------------------------------------------------------------",
   " ",
   "    0x64           Netware 286 File System Partition",
   "    0x65           Netware 386 File System Partition (3.x/4.x/5.x)",
   "    0x66           Netware SMS Partition",
   "    0x67           Wolf Mountain OS (UFOD)",
   "    0x69           Netware Storage Services (NSS)",
   " ",
   "    Traditional Netware volumes for versions 3.x, 4.x, and 5.x all",
   "    use partition type 0x65.  This utility allows you to create",
   "    Netware partitions of type 0x65 to support traditional Netware",
   "    file systems.",
   " ",
   "    Netware 3.x and Netware 4.x/5.x do in fact initialize type 0x65",
   "    partitions slightly differently, however, these differences are",
   "    subtle, and do not prevent either version from using these",
   "    parition formats interchangeably.  Netware mirroring for 3.x,",
   "    4.x, and 5.x are all identical in terms of partition flags and",
   "    hotfix/mirroring layout schemes.  It is recommended that you",
   "    create all partitions as Netware 4.x/5.x partitions by default.",
   " ",
   "    This utility will allow you to manage Netware partitions.  It",
   "    should be noted that making changes to the partition tables of",
   "    a disk drive can cause data loss if done improperly, so it is",
   "    strongly advised that you be familiar with the process of",
   "    managing disk partitions before attempting to add or remove",
   "    partitions from a particular device.",
   " ",
   "    Netware 3.x and 4.x will not allow you to create more than one",
   "    type 0x65 partition per disk.  Netware 4.x Media Manager seems to",
   "    be able to read and mount volumes that span more than one Netware",
   "    type 0x65 partition on a particular disk for Netware 4.x despite",
   "    this limitation, however, the INSTALL.NLM in Netware 4.x prohibits",
   "    users from creating more than a single partition per disk. Novell's",
   "    4.x documentation recommends against doing this due to",
   "    unpredictable side effects in the 3.x/4.x file system.",
   " ",
   "    Netware 5.x allows users to create up to 4 Netware partitions",
   "    on a single disk device, and fully supports multiple type 0x65",
   "    partitions on the same device.",
   " ",
   " ",
   "                 PARTITION MIRRORING CONFIGURATION",
   "                 ---------------------------------",
   " ",
   "    Netware mirroring works at the disk partition level.  Netware",
   "    allows up to 8 partitions to be mirrored with each other per group.",
   "    If partitions are mirrored across disk controllers, in Netware lingo",
   "    this is referred to as disk duplexing.  A group of partitions that",
   "    are mirrored with each other are referred to as a mirror group.",
   "    If a device hosting a mirrored partition fails, then the Netware",
   "    file system switches over to an in-sync partition that is a member",
   "    of that mirror group.  If a partition goes down, then comes back",
   "    or if you add a new partition to an existing mirror group, the ",
   "    system detects it, and remirrors (re-syncs) the added partition",
   "    so it is consistent with other partitions in the mirror group.",
   "    There is no limit as to how many mirror groups can be created.",
   "    You can create as many mirror groups as you want.",
   " ",
   "    Remirroring can be a very I/O intense operation, but happens",
   "    very infrequently.   Remirroring will occur when you add new",
   "    partitions that are not in-sync, or when a failed partition is",
   "    re-added to a mirror group.  During remirroring, you can still",
   "    access and mount file systems that exist on the mirrored partitions",
   "    although performance is slower while remirroring is in process.",
   " ",
   "    The Netware file system load balances disk reads and round-robins",
   "    between any mirrors if mirroring is present to increase file system",
   "    performance. Netware mirroring also runs remotely across machines.",
   "    Generally, mirroring does increase I/O usage but provides a ",
   "    performance boost for disk reading and makes the file system more ",
   "    robust by providing fault tolerance.",
   " ",
   "    INS will allow you to select a primary partition and a new secondary",
   "    partition to add to a mirror group.  Any mirrored partition within",
   "    a mirror group can be used as a primary to add additional mirrored",
   "    partitions (since it is assumed that all members will be identical).",
   "    DEL will allow you to remove a partition from a mirror group if it",
   "    is an active member of a particular mirror group.  Mirrored partitions",
   "    record all members assigned to a mirror group.  If a device fails or",
   "    is not present, then a mirror group will continue to expect the ",
   "    mirrored partition to be present.  SPACE will activate (reconfigure)",
   "    invalid partition definitions for a mirror group and all of it's",
   "    assigned partitions.",
   " ",
   "    If you are re-activating an inactive mirror group, you will see a",
   "    PARTITION NOT PRESENT message for any partitions that could not be",
   "    located for this mirror group.  You cannot activate the mirror group",
   "    until you have either located these partitions (they may exist on a",
   "    disk device that is switched off, such as a RAID box or external disk",
   "    farm of some type, and need to be turned on and re-scanned), or",
   "    you have deleted these invalid partition definitions.  You can remove",
   "    invalid mirror group members by positioning the cursor bar over",
   "    each invalid definition, and pressing the DEL key.",
   " ",
   " ",
   "                          PARTITION HOTFIXING",
   "                          -------------------",
   " ",
   "    Netware partitions are divided into a hotfix data area, and a volume",
   "    segment data area.  The hotfix area typically occupies the first",
   "    section of a Netware partition.  Hotfixing occurs when the file",
   "    system detects a disk read or disk write error to the volume segment",
   "    data area of a partition, then redirects (hotfixes) the read or write",
   "    request to the hotfix data area transparently.  This allows the file",
   "    system to handle disk errors without interrupting user access or",
   " ",
   "    On most modern disk drives, hotfixing never happens because the",
   "    disk provides an internal type of hotfix support.  However, hotfixing",
   "    does provide some benefit on devices that do not provide this",
   "    capability, and is an excellent method of handling disk errors.",
   "    If an error occurs reading or writing the hotfix data area, the" ,
   "    Netware file system will hotfix the hotfix table and is self-healing.",
   " ",
   "    Typically, the hotfix data area should only use about 0.2% of the",
   "    available space within a partition.  Using more will waste disk space",
   "    unless the device you are using is filled with bad sectors, then a",
   "    larger hotfix area is recommended.  During mirroring configuration,",
   "    there is a requirement that all mirrored partitions be identical in",
   "    size.  This is usually accomplished by re-sizing the hotfix data",
   "    area for a partition.  During mirroring configuration this is",
   "    performed automatically.  You also have the option of resizing the",
   "    hotfix data area by positioning the cursor bar over the partition",
   "    and pressing the ENTER key.  If a partition is already a member of",
   "    a mirror group, then you cannot re-size it's hotfix data area.",
   " ",
   " ",
   "                  VOLUME NAMESPACE CONFIGURATION",
   "                  ------------------------------",
   " ",
   "    By default, all Netware volumes have an MSDOS namespace that",
   "    supports 8.3 format filenames.  This namespace always exists ",
   "    on a Netware Volume.  Netware volumes can also support naming",
   "    for other operating systems that need special requirements.",
   " ",
   "    Netware volumes support namespaces that allow for file names",
   "    that are free form and up to 255 characters in length (LONG, NFS).",
   "    There is also support for Macintosh names and Macintosh Finder",
   "    Info and Resource Forks.  The OS your are running the NetWare",
   "    file system on will determine which namespaces you require.",
   "    If you are running the Netware file system on Linux, you should",
   "    use the NFS (Unix) namespace because it allows you to support",
   "    Unix style file permissions.  If you are using a Macintosh server",
   "    then you should use the Macintosh Namespace (MAC).  If you want",
   "    to use long names longer then the 8.3 MSDOS format, then you",
   "    should use the Long Namespace (LONG) or the NFS (Unix) Namespace.",
   " ",
   "    INS will allow you to add a new volume namespace.  Namespace",
   "    records are managed within the Netware volume directory file,",
   "    and require 128 bytes per record.  This means that you will",
   "    require 128 * number of files/directories of disk storage to",
   "    support the namespace you are adding.  If there is not enough",
   "    free disk space to add the namespace, then the operation will",
   "    not allow the namespace to be added.",
   " ",
   "    DEL will remove a namespace from a volume.  If you remove a ",
   "    namespace, the space allocated by the namespace records will",
   "    be marked as free in the directory file.",
   " ",
   "    Pressing enter will allow you to alter volume flags and enable",
   "    or disable specific volume features.  The features you can ",
   "    configure are:",
   " ",
   "    1.  Suballocation - this feature allows blocks of given size ",
   "        [4K, 8K, 16K, 32K, 64K] (as configured during volume create)",
   "        to be suballocated into 512 byte sectors to conserve volume",
   "        space.  Netware 4.x/5.x volumes support this feature, and it",
   "        is HIGHLY RECOMMENDED that you leave this feature alone and",
   "        turned on.  Larger block sizes result in faster performance",
   "        but unless suballocation is enabled, this can waste a lot of",
   "        disk space.  Netware 3.x does not support suballocation.",
   "        Once suballocation is enabled, it cannot be disabled.",
   " ",
   "    2.  File Compression - This will enable/disable Netware File",
   "        Compression for a volume.",
   " ",
   "    3.  Data Migration - Obsolete feature.  This feature is not ",
   "        supported, and will not doing anything if set.",
   " ",
   "    4.  Auditing - this flag enables volume auditing.",
   " ",
   "    5.  NDS - This flag tells the operating system if there are",
   "        Netware Directory Services databases within a hidden",
   "        directory (_NETWARE) on the volume.",
   " "
};

BYTE *PartitionHelp[]=
{
   " ",
   "                   DISK PARTITION CONFIGURATION",
   "                   ----------------------------",
   " ",
   "    Novell supports the following partition types:",
   " ",
   "    Type           Netware File System/OS",
   "    ------------------------------------------------------------",
   " ",
   "    0x64           Netware 286 File System Partition",
   "    0x65           Netware 386 File System Partition (3.x/4.x/5.x)",
   "    0x66           Netware SMS Partition",
   "    0x67           Wolf Mountain OS (UFOD)",
   "    0x69           Netware Storage Services (NSS)",
   " ",
   "    Traditional Netware volumes for versions 3.x, 4.x, and 5.x all",
   "    use partition type 0x65.  This utility allows you to create",
   "    Netware partitions of type 0x65 to support traditional Netware",
   "    file systems.",
   " ",
   "    Netware 3.x and Netware 4.x/5.x do in fact initialize type 0x65",
   "    partitions slightly differently, however, these differences are",
   "    subtle, and do not prevent either version from using these",
   "    parition formats interchangeably.  Netware mirroring for 3.x,",
   "    4.x, and 5.x are all identical in terms of partition flags and",
   "    hotfix/mirroring layout schemes.  It is recommended that you",
   "    create all partitions as Netware 4.x/5.x partitions by default.",
   " ",
   "    This utility will allow you to manage Netware partitions.  It",
   "    should be noted that making changes to the partition tables of",
   "    a disk drive can cause data loss if done improperly, so it is",
   "    strongly advised that you be familiar with the process of",
   "    managing disk partitions before attempting to add or remove",
   "    partitions from a particular device.",
   " ",
   "    Netware 3.x and 4.x will not allow you to create more than one",
   "    type 0x65 partition per disk.  Netware 4.x Media Manager seems to",
   "    be able to read and mount volumes that span more than one Netware",
   "    type 0x65 partition on a particular disk for Netware 4.x despite",
   "    this limitation, however, the INSTALL.NLM in Netware 4.x prohibits",
   "    users from creating more than a single partition per disk. Novell's",
   "    4.x documentation recommends against doing this due to",
   "    unpredictable side effects in the 3.x/4.x file system.",
   " ",
   "    Netware 5.x allows users to create up to 4 Netware partitions",
   "    on a single disk device, and fully supports multiple type 0x65",
   "    partitions on the same device.",
   " "
};

BYTE *NamespaceHelp[]=
{
   " ",
   "                  VOLUME NAMESPACE CONFIGURATION",
   "                  ------------------------------",
   " ",
   "    By default, all Netware volumes have an MSDOS namespace that",
   "    supports 8.3 format filenames.  This namespace always exists ",
   "    on a Netware Volume.  Netware volumes can also support naming",
   "    for other operating systems that need special requirements.",
   " ",
   "    Netware volumes support namespaces that allow for file names",
   "    that are free form and up to 255 characters in length (LONG, NFS).",
   "    There is also support for Macintosh names and Macintosh Finder",
   "    Info and Resource Forks.  The OS your are running the NetWare",
   "    file system on will determine which namespaces you require.",
   "    If you are running the Netware file system on Linux, you should",
   "    use the NFS (Unix) namespace because it allows you to support",
   "    Unix style file permissions.  If you are using a Macintosh server",
   "    then you should use the Macintosh Namespace (MAC).  If you want",
   "    to use long names longer then the 8.3 MSDOS format, then you",
   "    should use the Long Namespace (LONG) or the NFS (Unix) Namespace.",
   " ",
   "    INS will allow you to add a new volume namespace.  Namespace",
   "    records are managed within the Netware volume directory file,",
   "    and require 128 bytes per record.  This means that you will",
   "    require 128 * number of files/directories of disk storage to",
   "    support the namespace you are adding.  If there is not enough",
   "    free disk space to add the namespace, then the operation will",
   "    not allow the namespace to be added.",
   " ",
   "    DEL will remove a namespace from a volume.  If you remove a ",
   "    namespace, the space allocated by the namespace records will",
   "    be marked as free in the directory file.",
   " ",
   "    Pressing enter will allow you to alter volume flags and enable",
   "    or disable specific volume features.  The features you can ",
   "    configure are:",
   " ",
   "    1.  Suballocation - this feature allows blocks of given size ",
   "        [4K, 8K, 16K, 32K, 64K] (as configured during volume create)",
   "        to be suballocated into 512 byte sectors to conserve volume",
   "        space.  Netware 4.x/5.x volumes support this feature, and it",
   "        is HIGHLY RECOMMENDED that you leave this feature alone and",
   "        turned on.  Larger block sizes result in faster performance",
   "        but unless suballocation is enabled, this can waste a lot of",
   "        disk space.  Netware 3.x does not support suballocation.",
   "        Once suballocation is enabled, it cannot be disabled.",
   " ",
   "    2.  File Compression - This will enable/disable Netware File",
   "        Compression for a volume.",
   " ",
   "    3.  Data Migration - Obsolete feature.  This feature is not ",
   "        supported, and will not doing anything if set.",
   " ",
   "    4.  Auditing - this flag enables volume auditing.",
   " ",
   "    5.  NDS - This flag tells the operating system if there are",
   "        Netware Directory Services databases within a hidden",
   "        directory (_NETWARE) on the volume.",
   " "
};

BYTE *MirroringHelp[]=
{
   " ",
   "                 PARTITION MIRRORING CONFIGURATION",
   "                 ---------------------------------",
   " ",
   "    Netware mirroring works at the disk partition level.  Netware",
   "    allows up to 8 partitions to be mirrored with each other per group.",
   "    If partitions are mirrored across disk controllers, in Netware lingo",
   "    this is referred to as disk duplexing.  A group of partitions that",
   "    are mirrored with each other are referred to as a mirror group.",
   "    If a device hosting a mirrored partition fails, then the Netware",
   "    file system switches over to an in-sync partition that is a member",
   "    of that mirror group.  If a partition goes down, then comes back",
   "    or if you add a new partition to an existing mirror group, the ",
   "    system detects it, and remirrors (re-syncs) the added partition",
   "    so it is consistent with other partitions in the mirror group.",
   "    There is no limit as to how many mirror groups can be created.",
   "    You can create as many mirror groups as you want.",
   " ",
   "    Remirroring can be a very I/O intense operation, but happens",
   "    very infrequently.   Remirroring will occur when you add new",
   "    partitions that are not in-sync, or when a failed partition is",
   "    re-added to a mirror group.  During remirroring, you can still",
   "    access and mount file systems that exist on the mirrored partitions",
   "    although performance is slower while remirroring is in process.",
   " ",
   "    The Netware file system load balances disk reads and round-robins",
   "    between any mirrors if mirroring is present to increase file system",
   "    performance.  Netware mirroring also runs remotely across machines.",
   "    Generally, mirroring does increase I/O usage but provides a",
   "    performance boost for disk reading and makes the file system more",
   "    robust by providing fault tolerance.",
   " ",
   "    INS will allow you to select a primary partition and a new secondary",
   "    partition to add to a mirror group.  Any mirrored partition within",
   "    a mirror group can be used as a primary to add additional mirrored",
   "    partitions (since it is assumed that all members will be identical).",
   "    DEL will allow you to remove a partition from a mirror group if it",
   "    is an active member of a particular mirror group.  Mirrored partitions",
   "    record all members assigned to a mirror group.  If a device fails or",
   "    is not present, then a mirror group will continue to expect the ",
   "    mirrored partition to be present.  SPACE will activate (reconfigure)",
   "    invalid partition definitions for a mirror group and all of it's",
   "    assigned partitions.",
   " ",
   "    If you are re-activating an inactive mirror group, you will see a",
   "    PARTITION NOT PRESENT message for any partitions that could not be",
   "    located for this mirror group.  You cannot activate the mirror group",
   "    until you have either located these partitions (they may exist on a",
   "    disk device that is switched off, such as a RAID box or external disk",
   "    farm of some type, and need to be turned on and re-scanned), or",
   "    you have deleted these invalid partition definitions.  You can remove",
   "    invalid mirror group members by positioning the cursor bar over",
   "    each invalid definition, and pressing the DEL key.",
   " ",
   " ",
   "                          PARTITION HOTFIXING",
   "                          -------------------",
   " ",
   "    Netware partitions are divided into a hotfix data area, and a volume",
   "    segment data area.  The hotfix area typically occupies the first",
   "    section of a Netware partition.  Hotfixing occurs when the file",
   "    system detects a disk read or disk write error to the volume segment",
   "    data area of a partition, then redirects (hotfixes) the read or write",
   "    request to the hotfix data area transparently.  This allows the file",
   "    system to handle disk errors without interrupting user access or",
   "    losing file system data.  The segment data area of a Netware partition",
   "    is the region that is mirrored with other partitions within a mirror",
   "    group.  The hotfix data area of a Netware partition is not mirrored",
   "    and is specific to a particular partition.",
   " ",
   "    On most modern disk drives, hotfixing never happens because the",
   "    disk provides an internal type of hotfix support.  However, hotfixing",
   "    does provide some benefit on devices that do not provide this",
   "    capability, and is an excellent method of handling disk errors.",
   "    If an error occurs reading or writing the hotfix data area, the" ,
   "    Netware file system will hotfix the hotfix table and is self-healing.",
   " ",
   "    Typically, the hotfix data area should only use about 0.2% of the",
   "    available space within a partition.  Using more will waste disk space",
   "    unless the device you are using is filled with bad sectors, then a",
   "    larger hotfix area is recommended.  During mirroring configuration,",
   "    there is a requirement that all mirrored partitions be identical in",
   "    size.  This is usually accomplished by re-sizing the hotfix data",
   "    area for a partition.  During mirroring configuration this is",
   "    performed automatically.  You also have the option of resizing the",
   "    hotfix data area by positioning the cursor bar over the partition",
   "    and pressing the ENTER key.  If a partition is already a member of",
   "    a mirror group, then you cannot re-size it's hotfix data area.",
   " "
};

BYTE *SegmentHelp[]=
{
   " ",
   "                    VOLUME SEGMENT CONFIGURATION",
   "                    ----------------------------",
   " ",
   "    The segment editor allows you to create and manage segments and",
   "    assign them to create Netware volumes.   Netware partitions are",
   "    displayed in numeric order in the segment display window and any",
   "    space not currently assigned to existing Netware volumes is",
   "    annotated as ***FREE***.  Pressing the TAB key from the main",
   "    menu will switch you to the segment editor screen.",
   " ",
   "    There are performance benefits to striping segments across multiple",
   "    disk devices if present.",
   " ",
   "    Segments are the logical representation of a Mirror Group.  The",
   "    MirrorGroup number for each segment corresponds to the active",
   "    mirror group that makes up this segment of storage.",
   " ",
   "                      CREATING A NETWARE VOLUME",
   "                      -------------------------",
   " ",
   "    Prior to attempting to create a Netware volume, it is assumed that",
   "    you have first created a Netware Partition or Partitions, and that",
   "    you have also configured mirroring (if desired).  If you have not",
   "    completed these steps, then you should review the sections on",
   "    mirroring and paritition management before attempting to create",
   "    a Netware volume.",
   " ",
   "    NetWare volumes can consist of from 1 to 32 segments.  Segments",
   "    for a particular volume can exist on a single drive, or can be ",
   "    spanned (striped) across multiple drives.  Up to 8 segments ",
   "    can be created within a given Netware 3.x or 4.x/5.x partition.",
   " ",
   "    To Create a Netware Volume, you must first select and mark a group",
   "    of free segments that will comprise the volume.  You mark segments",
   "    by switching to the volume segment editor panel (by pressing the TAB",
   "    key from the main menu) and moving the cursor bar over a defined ",
   "    ***FREE*** segment, and pressing the SPACE bar. If you want to create",
   "    multiple segments from a block of partition ***FREE*** space, then ",
   "    move the cursor bar over the free area, and press ENTER.  You can ",
   "    then enter a size value in megabytes to define a segment you want to",
   "    split out of the block of free space.  You are limited to 8 segment",
   "    definitions for each partition.",
   " ",
   "    After you have marked your segment definitions and split free space",
   "    into the segment sizes you wish to use, then you can press ESC/F3, and",
   "    select the CREATE NETWARE VOLUME option on the main menu to complete",
   "    naming of the volume and specific options you may want to enable for",
   "    the volume.",
   " ",
   "    Netware volumes can also be extended after they have been created.",
   "    This allows administrators to add disks and storage to a server, and",
   "    extend the size of a volume by adding new segments to the end of the",
   "    volume.  If these segments span disks, the Netware file system",
   "    naturally load balances and stripes data across these segments.",
   "    You expand a volume by marking segments and defining them as described",
   "    above, and pressing ESC/F3 and selecting CREATE OR EXPAND VOLUME.",
   " ",
   "    If for any reason you have created a split segment definition and",
   "    you change your mind about your settings, you can press the DEL key",
   "    and clear your current segment definitions back to the default",
   "    values.",
   " ",
   "    Volume create allows you to determine which attributes a volume",
   "    will have.  The default values are the best choice, and should not",
   "    be altered unless you know what you are doing.",
   " "
};
